package com.insomnia.GUI;

import com.insomnia.parser.RequestData;
import com.insomnia.parser.ResponseData;
import com.insomnia.parser.Saver;

import javax.swing.*;
import javax.swing.border.Border;
import java.awt.*;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

public class LeftPanel extends JPanel {
    Border border = BorderFactory.createLineBorder(Color.BLACK,3);
    VerticalFlowLayout vfLayout = new VerticalFlowLayout();
    JButton addRequest = new JButton("Add Request");
    JMenu menu = new JMenu("Insomnia");
    JPanel requestList = new JPanel(vfLayout);
    JScrollPane scrollRequests = new JScrollPane(requestList);
    JPanel up_left = new JPanel(new GridLayout(2,1));


    //left panel (list of requests)
    public void createLeftPanel() {
        menu.setFont(new Font("Arial",20,15 ));
        menu.setBorder(border);
        menu.setPreferredSize(new Dimension(200,60));
        up_left.add(menu);
        up_left.add(addRequest);
        up_left.setBackground(Color.GRAY);
        requestList.setBackground(Color.GRAY);
        addRequest.addMouseListener(new MouseAdapter() {
            @Override
            public void mouseClicked(MouseEvent e) {
                RequestData requestData = new RequestData();
                ResponseData responseData = new ResponseData(requestData);
                JFrame newRequestFrame = new JFrame("request name");
                JLabel label = new JLabel("new request");
                JTextField textField = new JTextField();
                JPanel panel = new JPanel();
                label.setBounds(40,40,40,30);
                textField.setBounds(100, 40, 100,30);
                JButton  create = new JButton("create");
                textField.setPreferredSize(new Dimension(70,50));
                panel.add(label);
                panel.add(textField);
                panel.add(create);
                newRequestFrame.add(panel);
                newRequestFrame.setPreferredSize(new Dimension(200,200));
                newRequestFrame.setVisible(true);
                requestData.setName(textField.getText());
                create.addMouseListener(new MouseAdapter() {
                    @Override
                    public void mouseClicked(MouseEvent e) {
                        super.mouseClicked(e);
                        requestData.setName(textField.getText());
                        JButton newRequest = new JButton(requestData.getName());
                        newRequest.addMouseListener(new MouseRequestClick(requestData , responseData ));
                        requestList.add(newRequest);
                        //ToDo:add action listener to button requests
                    }
                });
            }
        });
        this.setLayout(new BorderLayout());
        this.setBackground(Color.GRAY);
        this.add(up_left, BorderLayout.NORTH);
        this.add(scrollRequests, BorderLayout.CENTER);
        this.setBackground(Color.LIGHT_GRAY);
    }

    public JButton getAddRequest() {
        return addRequest;
    }

    public JMenu getMenu() {
        return menu;
    }

    public JPanel getRequestList() {
        return requestList;
    }

    public JScrollPane getScrollRequests() {
        return scrollRequests;
    }

    public JPanel getUp_left() {
        return up_left;
    }

    private class MouseRequestClick extends MouseAdapter {
        Saver saver = new Saver();
        RequestData requestData = new RequestData();
        ResponseData responseData = new ResponseData(requestData);
        MouseRequestClick(RequestData requestData , ResponseData responseData){
            this.requestData = requestData;
            this.responseData = responseData;
        }
         @Override
        public void mouseClicked(MouseEvent e){
            super.mouseClicked(e);
        }
    }
}

